'Build Version: 3.0.118.0

'***********************************************************************
' THIS CODE AND INFORMATION IS PROVIDED TO YOU FOR YOUR REFERENTIAL 
' PURPOSES ONLY, AND IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE, 
' AND MAY NOT BE REDISTRIBUTED IN ANY MANNER.
' 
' Copyright (c) 2004  Microsoft Corporation.  All rights reserved.
'***********************************************************************
	' Set Constants
	Const ADS_ACEFLAG_INHERITED_ACE			= &H10
	Const ADS_ACETYPE_ACCESS_ALLOWED		= &H0
	Const ADS_ACETYPE_ACCESS_DENIED			= &H1
	Const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT		= &H5
	Const ADS_ACETYPE_ACCESS_DENIED_OBJECT		= &H6

Dim strWBHGrpSamName
Dim sDomainDN
Dim dse
Dim configObjectDN
Dim configObject
Dim heuristics
Dim newHeuristics

'********************************************************************
'*
'* File:        secureAD.VBS
'* Created:     April 2000, revised January 2004
'* Version:     2.0
'*
'* Main Function: Removes Authenticated Users security group from Active Directory '* Default containers. 
'* Intended For use in a Shared Hosting Active Directory Forest Model.
'* Usage: secureAD.vbs
'*
'* Copyright (C) 1998 - 2004 Microsoft Corporation
'*
'********************************************************************
' Bind to the root of the Domain
Set rootDSE = GetObject("LDAP://RootDSE")
' Get the default NamingContext
sDomainDN = rootDSE.Get("defaultNamingContext")

' Set AD to List Object Mode
configObjectDN = "LDAP://CN=Directory Service,CN=Windows NT,CN=Services,"
configObjectDN = configObjectDN & rootDSE.Get("configurationNamingContext")
Set configObject = GetObject(configObjectDN)
GetHeuristics
write "Current DSheuristics: " & heuristics
newHeuristics = Left(heuristics, 2)
newHeuristics = newHeuristics & Left("00", 2-Len(newHeuristics))
newHeuristics = newHeuristics & "1"
Write "New DSheuristics: " & newheuristics
If Len(heuristics) > 3 Then
  newHeuristics = newHeuristics & Right(heuristics, Len(heuristics)-3)
End If
configObject.Put "dSHeuristics", newHeuristics
configObject.SetInfo

' Need to ensure the basic group memberships are setup correctly
VerifyGroups

' Call the CleanOU function for each of the default containers in AD
' this removes the Authenticated Users from the Containers we do not want them
' to have access to
CleanOu "LDAP://cn=Builtin," & sDomainDN
CleanOu "LDAP://cn=Computers," & sDomainDN
CleanOu "LDAP://ou=Domain Controllers," & sDomainDN
CleanOu "LDAP://cn=ForeignSecurityPrincipals," & sDomainDN
CleanOu "LDAP://cn=Infrastructure," & sDomainDN
CleanOu "LDAP://cn=System," & sDomainDN
CleanOu "LDAP://cn=Users," & sDomainDN

' Now let's see if we have an OU Parmeter specified and verify it
' if it does not exist we create it and secure it.
If WScript.Arguments.Named.Exists("OU") Then
    On Error Resume Next
    Set oOU = GetObject("LDAP://OU=" & WScript.Arguments.Named("OU")) & "," & strDomainDN
    If Not IsObject(oOU) Then
        Set oDomain = GetObject("LDAP://" & sDomainDN)
        Set oOU = oDomain.Create("organizationalUnit","OU=" & WScript.Arguments.Named("OU"))
        oOU.Description = "Hosting OU used as the parent for all Customer Organizations."
        oOU.Setinfo
    End If
    ' Now Clean up the ACL on the OU
    CleanOU oOU.AdsPath     

Else
    WScript.Echo "No OU Specified."
End If


Function CleanOU(g_objOu)
	Dim AceCount
	wScript.Echo " "
	wScript.Echo "Cleaning: " & g_objOu
	Set sAdServer = GetObject(g_objOu)

	' Set Proper Ace Entries
	Set SecurityDescriptor = sAdServer.Get("ntSecurityDescriptor")
	
	Set Dacl = SecurityDescriptor.DiscretionaryAcl

	' Remove the ability for any user in the Directory to access this
	'	OU or its object
	DeleteAce Dacl, "Everyone"

	' If you delete the Authenticated Users, Group Policies will no longer work
	DeleteAce Dacl, "NT AUTHORITY\Authenticated Users"	
	
	' Not sure what effect this may have on applications.
	'DeleteAce Dacl, "BUILTIN\Pre-Windows 2000 Compatible Access

    ' now add the Windows-based Hosting Service Accounts Group to the DACL
        AddAce Dacl, strWBHGrpSamName ,148, 0, 0, 0, 0,0
	' Add New Dacl to the Security Descriptor
	'SecurityDescriptor.discretionaryAcl = ReorderACL(dacl,false)
	SecurityDescriptor.DiscretionaryAcl = Dacl
	Write "DACL Now"
	For each a in dacl
		Write a.trustee & "=" & a.Flags
	Next
	
	sAdServer.put "ntSecurityDescriptor", Array(SecurityDescriptor)

	' Save Information to the Directory
	sAdServer.SetInfo

	Set sAdServer = Nothing
End Function

'********************************************************************
'*
'* Function AddAce(dacl, TrusteeName, gAccessMask, gAceType,_
'*				 gAceFlags, gFlags, gObjectType, gInheritedObjectType)
'*
'* Purpose: Adds and ACE to an existing ACL
'* Input:   	dacl						Access Control List (Object)
'*				TrusteeName			Name of Trustee to add (String)
'*				gAccessMask			AccessMask (String)
'*				gAceType			AceType ()
'*				gAceFlags			AceFlags ()
'*				gFlags				Flags ()
'*				gObjectType			ObjectType ()
'*				gInheritedObjectType		InheritedObjectType ()
'*				
'* Output:  None
'*
'********************************************************************
Function AddAce(dacl, TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
' Bubble Error to Calling Function
'On Error Resume Next
	Dim Ace1
	' Add New Ace for Apply Policy
	write "creating ACE for WBH Group"
	Set Ace1 = CreateObject("AccessControlEntry")
	'write "AccessMask: " & gAccessMask
	Ace1.AccessMask = gAccessMask
	Ace1.AceType = gAceType
	Ace1.AceFlags = gAceFlags
	'Ace1.Flags = gFlags
	Ace1.Trustee = TrusteeName

    'Check to See if ObjectType needs to be set
    If CStr(gObjectType) <> 0 Then
    'Ace1.ObjectType = gObjectType
    End If
    
    'Check to See if InheritedObjectType needs to be set
    If cStr(gInheritedObjectType) <> 0 Then
    'Ace1.InheritedObjectType = ADS_ACEFLAG_INHERITED_ACE
    End If
	dacl.AddAce Ace1
	
	' Kill Objects
	Set Ace1 = Nothing
End Function

Function DeleteAce(Dacl, TrusteeName)
	Set oACE = CreateObject("AccessControlEntry")
		For Each oAce in dacl
			if (oAce.Trustee = TrusteeName) then
				wScript.Echo "Found and Deleted: " & TrusteeName
				dacl.RemoveAce(oAce)
			End if
		Next		
End Function

Function VerifyGroups()
' Find the Windows-based Hosting Service Accounts Group
strAdsPath = FindObject("Windows-based Hosting Service Accounts","group","AdsPath",sDomainDN,True,"name",False)
If strADsPath = "" Then
    ' Group not found need to create it
    Set oCont = GetObject("LDAP://cn=Users," & sDomainDN)
    Set oGrp = oCont.Create("group","cn=Windows-based Hosting Service Accounts Group")
    oGrp.SamAccountName = "WBHSvcAccts"
    oGrp.SetInfo
    strWBHGrpSamName = oGrp.SamAccountName
else
    ' We need to set the strWBHGrpSamName Variable to the exisiting WBH Group
    Set oGrp = GetObject(strADsPath)
    strWBHGrpSamName = oGrp.SamAccountName
End If

' Add the Windows-based Hosting Service Accounts Group to the Read ACL of the Domain Object
Set sAdServer = GetObject("LDAP://" & sDomainDN)
' Set Proper Ace Entries
Set SecurityDescriptor = sAdServer.Get("ntSecurityDescriptor")
Set Dacl = SecurityDescriptor.DiscretionaryAcl
' now add the Windows-based Hosting Service Accounts Group to the DACL
AddAce Dacl, strWBHGrpSamName ,148, 0, 0, 0, 0,0
SecurityDescriptor.DiscretionaryAcl = Dacl
sAdServer.put "ntSecurityDescriptor", Array(SecurityDescriptor)
' Save Information to the Directory
sAdServer.SetInfo      

' Add the Domain Computers Group to the OU=Servers OU if it is not there create it.
Dim strAdPath
strAdPath = VerifyOU("Servers")
write "Verify OU returned " & strAdPath
If strAdPath <> "" Then
    Set sAdServer = GetObject("LDAP://cn=computers," & sDomainDN)
    ' Set Proper Ace Entries
    Set SecurityDescriptor = sAdServer.Get("ntSecurityDescriptor")
    Set Dacl = SecurityDescriptor.DiscretionaryAcl
    ' now add the Windows-based Hosting Service Accounts Group to the DACL
    AddAce Dacl, "Domain Computers" ,148, 0, 0, 0, 0,0
    SecurityDescriptor.DiscretionaryAcl = Dacl
    sAdServer.put "ntSecurityDescriptor", Array(SecurityDescriptor)
    ' Save Information to the Directory
    sAdServer.SetInfo
           
    Set sAdServer = GetObject(strAdPath)
    ' Set Proper Ace Entries
    Set SecurityDescriptor = sAdServer.Get("ntSecurityDescriptor")
    Set Dacl = SecurityDescriptor.DiscretionaryAcl
    ' now add the Windows-based Hosting Service Accounts Group to the DACL
    AddAce Dacl, "Domain Computers" ,148, 0, 0, 0, 0,0
    SecurityDescriptor.DiscretionaryAcl = Dacl
    sAdServer.put "ntSecurityDescriptor", Array(SecurityDescriptor)
    ' Save Information to the Directory
    sAdServer.SetInfo        
Else
    write "OU=Servers could not be verified."
End if
' now find the Pre-Windows 2000 Compatible Access Group
strAdsPath = FindObject("Pre-Windows 2000 Compatible Access","group","AdsPath",sDomainDN,False,"name",False)
If strAdsPath <> "" Then
    ' Found it (if not something is seriously wrong)
    ' Now bind to the group and remove the Anonymous Users Group from the Membership List
    ' S-1-5-11 is the WellKnown SID of the User Account.
    Set oGrp = GetObject(strAdsPath)
    For each g in oGrp.Members
    write g.AdsPath
	if g.AdsPath = "LDAP://CN=S-1-5-11,CN=ForeignSecurityPrincipals," & sDomainDN then
	    oGrp.Remove ("LDAP://CN=S-1-5-11,CN=ForeignSecurityPrincipals," & sDomainDN)
	end if
    next
    oGrp.SetInfo
End If

End Function
Function VerifyOU(strName)
VerifyOU = ""
Dim tObj,tCont
On Error Resume Next
Set tCont = GetObject("LDAP://" & sDomainDN)
Set tObj = GetObject("LDAP://OU=" & strName)
If IsObject(tObj) Then
    VerifyOU = tObj.Adspath
Else
    Set tObj =  tCont.Create("organizationalUnit","OU=" & strName)
    tObj.Description = "Organizational Unit for hosted servers"
    tObj.SetInfo
    If IsObject(tObj) Then
        VerifyOU = tObj.Adspath
    End If
End If

End Function

'********************************************************************
'*
'* Function ReorderACL(objDACL)
'*
'* Purpose: Reorders a DACL properly
'* Input:   	objDACL						Access Control List (Object)
'*				bMakeExplicit				Determinse if whether or not inherited
'*											ACE Settings should be stripped (boolean)
'*				
'* Output:  Object - Reordered DACL
'*
'********************************************************************
Function ReorderACL(objDACL, bMakeExplicit)
	' Dim Objects
	Dim ImpDenyDacl, ImpDenyObjectDacl, InheritedDacl, ImpAllowDacl, ImpAllowObjectDacl
	Dim objSD, newDACL
	
	' Dim Other Variables
	Dim ace
	
	
	' Create the New DACL
	Set objSD = CreateObject("SecurityDescriptor")
	
	' Create the ACL Objects
	Set newDACL			= CreateObject("AccessControlList")
	Set ImpDenyDacl			= CreateObject("AccessControlList")
	Set ImpDenyObjectDacl		= CreateObject("AccessControlList")
	Set InheritedDacl		= CreateObject("AccessControlList")
	Set ImpAllowDacl		= CreateObject("AccessControlList")
	Set ImpAllowObjectDacl		= CreateObject("AccessControlList")
	
	    ' Loop through the Original Dacl.
    For Each ace In objDACL
    If bMakeExplicit Then
         If ((ace.AceFlags And ADS_ACEFLAG_INHERITED_ACE) = ADS_ACEFLAG_INHERITED_ACE) Then
            ace.AceFlags = ace.AceFlags Xor ADS_ACEFLAG_INHERITED_ACE
        End If
   Else
                 ' Don't really care about the order of inherited aces.  Since we are
            ' adding them to the top of a new list, when they are added back
            ' to the Dacl for the object, they will be in the same order as they were
            ' originally.  Just a positive side affect of addin items or a LIFO
            ' (Last In First Out) type list'
           InheritedDacl.AddAce ace
            
    End If
            ' We have an Implicit Ace, lets put it in the proper pool
            Select Case ace.AceType
                Case ADS_ACETYPE_ACCESS_ALLOWED
                    ImpAllowDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_DENIED
                    ImpDenyDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_ALLOWED_OBJECT
                    ImpAllowObjectDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_DENIED_OBJECT
                    ImpDenyObjectDacl.AddAce ace
                Case Else
                    'Bad Ace, but let's just leave it out for now.
            End Select
    
    Next
	'
	' Combine the ACEs in the Proper Order
	'	Implicit Deny
	'	Implicit Deny Object
	'	Implicit Allow
	'	Implicit Allow Object
	'	Inherited ACEs
	'
	
	' Implicit Deny
		For Each ace in ImpDenyDacl
			newDACL.AddAce ace
		Next
		
	' Implicit Deny Object
		For Each ace in ImpDenyObjectDacl
			newDACL.AddAce ace
		Next
		
	' Implicit Allow
		For Each ace in ImpAllowDacl
			newDACL.AddAce ace
		Next
		
	' Implicit Allow Object
		For Each ace in ImpAllowObjectDacl
			newDACL.AddAce ace
		Next
		
	' Inherited ACEs
		For Each ace in InheritedDacl
			newDACL.AddAce ace
		Next
	
	'Set the Appropriate revision level for the DACL
	newDACL.AclRevision = objDACL.AclRevision
	
	' Return Properly Ordered DACL
	Set ReorderACL = newDACL
	
	' Kill Objects
	Set newDACL					= Nothing
	Set InheritedDacl			= Nothing
	Set ImpAllowObjectDacl		= Nothing
	Set ImpAllowDacl			= Nothing
	Set ImpDenyObjectDacl		= Nothing
	Set ImpDenyDacl				= Nothing
	Set objSD					= Nothing
	
End Function




Function FindObject(strToFind,strClass,ResultList,DNtosearch,bANR,attrToFind,bUseGC)
   bAnr = cbool(bAnr)
     
  Set con = CreateObject("ADODB.Connection")
  Set com =   CreateObject("ADODB.Command")
  If bUseGC Then 
    domainPath = "GC://" & DNtosearch
  Else
    domainPath = "LDAP://" & DNtosearch
  End if
  
    
  'Open the ADSI Connection.
  con.Provider = "ADsDSOObject"

  'Credentials  
   'con.Properties("User ID") = "NTDEV\ntdev"
   'con.Properties("Password") = "ntdevntdev"

   con.Open "Ads Provider"
   Set Com.ActiveConnection = con
   Write "Searching for: "
   Write strToFind
   Write strClass
   Write ResultList
   Write DNtoSearch
   Write bANR
   Write attrToFind
   
   If bANR = True then
   		Com.CommandText = "<" & domainPath & ">;(&(anr=" & strToFind & ")(|(objectClass=" & strClass & ")));name,samaccountname," & ResultList & ";subtree"
   else
   		Com.CommandText = "<" & domainPath & ">;(&(" & attrToFind & "=" & strToFind & ")(|(objectCategory=" & strClass & ")));" & ResultList & ";subtree"
   end if
   
   Com.Properties("Page Size") = 1000
   Com.Properties("Timeout") = 30 'seconds

   '--- TIME BEGIN
   write "Searching..."
   write Com.CommandText
   t = Timer
   Set rs = Com.Execute
   elapse = Mid(CStr(Timer - t),1,5)
   '--- TIME END
   'On Error Resume Next
   counter = 0

Count = rs.RecordCount
If count <> 0 then
	write "Found " & Count & " Records."
	rs.MoveFirst
	splitAttr = Split(ResultList,",")
	counter = 0
	While Not rs.EOF
		write counter
		 For i = 0 To UBound(SplitAttr)
	 		if i = 0 Then 
	 			tStr = rs.Fields(SplitAttr(i))
		 	Else
		 		tstr = tstr & "|" & rs.Fields(splitAttr(i))
	 		End if
		 next
	     'Increment the counter 
	     counter = counter + 1 
	     write tstr        
	     rs.MoveNext
	Wend
	FindObject = tstr
end if
End Function

Function write(strToWrite)
    WScript.Echo strToWrite
End Function

Sub GetHeuristics
  On Error Resume Next
  heuristics = configObject.Get("dSHeuristics")
  If Err Then
    If Err.Number = &H8000500D Then
' no error -- the dSHeuristics attribute was just unset
      heuristics = ""
    Else
      WScript.Echo Err.Description
      WScript.Quit(1)
    End If
  End If
End Sub
